(require racket/hash)

(define racket-libdir "/usr/lib64/racket")

(define mans.rktd (build-path racket-libdir "mans.rktd"))
(define mans.d (build-path racket-libdir "mans.d"))

(define (list-files directory-path)
  (map (lambda (file)
	 (build-path directory-path (path->string file)))
       (directory-list directory-path)))

(define (list-rktd-files directory-path)
  (define all-files (map (lambda (file)
			   (path->string file))
			 (list-files directory-path)))
  (filter (lambda (file) (regexp-match #rx".rktd$" file))
	  all-files))

(define (merge-file-pieces files)
  (define summary (make-hash '()))
  (for-each (lambda (file)
	      (hash-union! summary (file->value file)
			   #:combine/key (lambda (k v1 v2) v2)))
	    (sort files string<?))
  summary)

(when (file-exists? mans.rktd)
  (delete-file mans.rktd))

(with-output-to-file mans.rktd
    (lambda ()
      (pretty-write (merge-file-pieces (list-rktd-files mans.d)))))

